#ifndef GABA_DEFINE
struct command_continuation
{
  struct lsh_object super;
  int (*(c))(struct command_continuation *self, struct lsh_object *result);
};
extern struct lsh_class command_continuation_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
struct lsh_class command_continuation_class =
{ STATIC_HEADER,
  0, "command_continuation", sizeof(struct command_continuation),
  NULL,
  NULL
};
#endif /* !GABA_DECLARE */

#ifndef GABA_DEFINE
struct command
{
  struct lsh_object super;
  int (*(call))(struct command *self, struct lsh_object *arg, struct command_continuation *c);
};
extern struct lsh_class command_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
struct lsh_class command_class =
{ STATIC_HEADER,
  0, "command", sizeof(struct command),
  NULL,
  NULL
};
#endif /* !GABA_DECLARE */

#ifndef GABA_DEFINE
struct command_simple
{
  struct command super;
  struct lsh_object * (*(call_simple))(struct command_simple *self, struct lsh_object *);
};
extern struct lsh_class command_simple_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
struct lsh_class command_simple_class =
{ STATIC_HEADER,
  &command_class, "command_simple", sizeof(struct command_simple),
  NULL,
  NULL
};
#endif /* !GABA_DECLARE */

#ifndef GABA_DEFINE
struct command_frame
{
  struct command_continuation super;
  struct command_continuation *up;
};
extern struct lsh_class command_frame_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void do_command_frame_mark(struct lsh_object *o, 
void (*mark)(struct lsh_object *o))
{
  struct command_frame *i = (struct command_frame *) o;
  mark((struct lsh_object *) i->up);
}

struct lsh_class command_frame_class =
{ STATIC_HEADER,
  &command_continuation_class, "command_frame", sizeof(struct command_frame),
  do_command_frame_mark,
  NULL
};
#endif /* !GABA_DECLARE */

#ifndef GABA_DEFINE
struct collect_info_4
{
  struct lsh_object super;
  struct lsh_object * (*(f))(struct collect_info_4 *self, struct lsh_object *, struct lsh_object *, struct lsh_object *, struct lsh_object *);
};
extern struct lsh_class collect_info_4_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
struct lsh_class collect_info_4_class =
{ STATIC_HEADER,
  0, "collect_info_4", sizeof(struct collect_info_4),
  NULL,
  NULL
};
#endif /* !GABA_DECLARE */

#ifndef GABA_DEFINE
struct collect_info_3
{
  struct lsh_object super;
  struct lsh_object * (*(f))(struct collect_info_3 *self, struct lsh_object *, struct lsh_object *, struct lsh_object *);
  struct collect_info_4 *next;
};
extern struct lsh_class collect_info_3_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void do_collect_info_3_mark(struct lsh_object *o, 
void (*mark)(struct lsh_object *o))
{
  struct collect_info_3 *i = (struct collect_info_3 *) o;
  mark((struct lsh_object *) i->next);
}

struct lsh_class collect_info_3_class =
{ STATIC_HEADER,
  0, "collect_info_3", sizeof(struct collect_info_3),
  do_collect_info_3_mark,
  NULL
};
#endif /* !GABA_DECLARE */

#ifndef GABA_DEFINE
struct collect_info_2
{
  struct lsh_object super;
  struct lsh_object * (*(f))(struct collect_info_2 *self, struct lsh_object *, struct lsh_object *);
  struct collect_info_3 *next;
};
extern struct lsh_class collect_info_2_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void do_collect_info_2_mark(struct lsh_object *o, 
void (*mark)(struct lsh_object *o))
{
  struct collect_info_2 *i = (struct collect_info_2 *) o;
  mark((struct lsh_object *) i->next);
}

struct lsh_class collect_info_2_class =
{ STATIC_HEADER,
  0, "collect_info_2", sizeof(struct collect_info_2),
  do_collect_info_2_mark,
  NULL
};
#endif /* !GABA_DECLARE */

#ifndef GABA_DEFINE
struct collect_info_1
{
  struct command_simple super;
  struct lsh_object * (*(f))(struct collect_info_1 *self, struct lsh_object *);
  struct collect_info_2 *next;
};
extern struct lsh_class collect_info_1_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void do_collect_info_1_mark(struct lsh_object *o, 
void (*mark)(struct lsh_object *o))
{
  struct collect_info_1 *i = (struct collect_info_1 *) o;
  mark((struct lsh_object *) i->next);
}

struct lsh_class collect_info_1_class =
{ STATIC_HEADER,
  &command_simple_class, "collect_info_1", sizeof(struct collect_info_1),
  do_collect_info_1_mark,
  NULL
};
#endif /* !GABA_DECLARE */

